﻿@Imports ThinkGeo.MapSuite.Core
@Imports ThinkGeo.MapSuite.MvcEdition
@Code
    ViewData("Title") = "Index"
End Code
<script language="javascript" type="text/javascript">
    function OnOverlaysDrawing(layers) {

        for (var index = 0; index < layers.length; index++) {
            var templayer = layers[index];
            if (OpenLayers.String.contains(templayer.CLASS_NAME, 'Google')) {
                templayer.options.numZoomLevels = 24;
                templayer.options.maxZoomLevels = 24;

                templayer.MIN_ZOOM_LEVEL = 0;
                templayer.MAX_ZOOM_LEVEL = 24;
                templayer.RESOLUTIONS.push(templayer.RESOLUTIONS[21] / 2);
                templayer.RESOLUTIONS.push(templayer.RESOLUTIONS[22] / 2);
                templayer.RESOLUTIONS.push(templayer.RESOLUTIONS[23] / 2);
            }
            if (OpenLayers.String.contains(templayer.CLASS_NAME, 'Bing')) {
                templayer.options.numZoomLevels = 24;
                templayer.resolutions.push(templayer.resolutions[19] / 2);
                templayer.resolutions.push(templayer.resolutions[20] / 2);
                templayer.resolutions.push(templayer.resolutions[21] / 2);
                templayer.resolutions.push(templayer.resolutions[22] / 2);
            }
        }
    }
</script>
<div style="height: 600px; width: 800px;">
    @Code
        Dim moreZoomlevelset As New ZoomLevelSet()
                    
        Dim googlezoomlevelsets As New GoogleMapsZoomLevelSet()
        For Each item As ZoomLevel In googlezoomlevelsets.GetZoomLevels()
            moreZoomlevelset.CustomZoomLevels.Add(item)
        Next
                    
        Dim zoomlevel21 As New ZoomLevel(moreZoomlevelset.GetZoomLevels()(moreZoomlevelset.GetZoomLevels().Count - 1).Scale / 2)
        Dim zoomlevel22 As New ZoomLevel(zoomlevel21.Scale / 2)
        Dim zoomlevel23 As New ZoomLevel(zoomlevel22.Scale / 2)
        Dim zoomlevel24 As New ZoomLevel(zoomlevel23.Scale / 2)
        moreZoomlevelset.CustomZoomLevels.Add(zoomlevel21)
        moreZoomlevelset.CustomZoomLevels.Add(zoomlevel22)
        moreZoomlevelset.CustomZoomLevels.Add(zoomlevel23)
        moreZoomlevelset.CustomZoomLevels.Add(zoomlevel24)
        
        Dim MapBuilder = Html.ThinkGeo.Map("Map1", New System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage), New System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage))
        MapBuilder.MapBackground(New BackgroundLayer(New GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"))))
        MapBuilder.MapUnit(GeographyUnit.Meter)
        MapBuilder.ZoomLevelSet(moreZoomlevelset)
        MapBuilder.MapTools(Sub(tools)
                                    tools.OverlaySwitcherMapTool().Enabled(False)
                                    tools.MouseCoordinateMapTool().Enabled(False)
                                    tools.KeyboardMapTool().Enabled(False)
                                    tools.LoadingImageMapTool().Enabled(True)
                            End Sub)
                    
        MapBuilder.CustomOverlays(Sub(overlays)
                                             
                                          ' Bing Map
                                          overlays.BingMapsOverlay("Bing").MapType(BingMapsStyle.Hybrid)
                                          ' Custom ShapeFile
                                          Dim worldLayer As ShapeFileFeatureLayer = New ShapeFileFeatureLayer(Server.MapPath("~/App_Data/austinstreets.shp"))
                                          ' here we use the default zoomlevel styles, and also we can define the custom zoomlevels for each zoomlevel styles like from 1 to 20 we use Highway3 style and from 20 to 24, we use Highway 4 to render.
                                          'worldLayer.ZoomLevelSet.CustomZoomLevels.Add ....
                                          worldLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.Highway3
                                          worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20

                                          Dim proj4 As Proj4Projection = New Proj4Projection()
                                          proj4.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326)
                                          proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString()
                                          worldLayer.FeatureSource.Projection = proj4

                                          overlays.LayerOverlay("WorldOverlay", False, TileType.MultipleTile).Name("Custom ShapeFile").Layer(worldLayer)
                                  End Sub)
        MapBuilder.CurrentExtent(-10888257.578281, 3550139.60333724, -10871812.5725451, 3531992.94634527)
        MapBuilder.Render()
    End Code
</div>
